.include "m16def.inc"	; 
.list			; 

;------------------------- 

.def	temp    = r16	   ; 
.def    Ind1    = r20      ; 1
.def    Ind2    = r21      ; 2 
.def    UprLed  = r22      
.def    Cnt     = r23      ;    

        jmp     Start              ;        
        jmp     OutInt             ;        0
        jmp     OutInt             ;     
        jmp     OutInt             ; 
        jmp     OutInt
        jmp     OutInt
        jmp     Timer              ;     1   OCR1A
        jmp     OutInt
        jmp     OutInt             ;       
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
        jmp     OutInt
;-------------------------- 	
Start:
        ldi temp,high(ramend)            ;   
        out SPH,temp
        ldi temp,low(ramend)
        out SPL,temp
;-------------------------- 			
;  
		ldi		temp, 0xFF	;            ;  -
		out		DDRA, temp	; 
		out		PORTA, temp	; 
		out		DDRC, temp	; 
		ldi		temp, 0
		out		PORTC, temp	; 
;--------------------------- 
		ldi 	temp, (1<<ACD)           ; 
		out		ACSR, temp
		ldi     temp,(1<<CS12 | 1<<CS10 | 1<<WGM12)  ;    1024 + 
		out     TCCR1B,Temp                          ;   
		ldi     temp,high(315)   ;   315    
		out     OCR1AH,temp      ;..   TCNT1   
		ldi     temp,low(315)    ;OCR1A   
		out     OCR1AL,temp
		ldi     temp,(1<<OCIE1A) ;     OCR1A
		out     TIMSK,temp

        ldi     UprLed,0b11111110 ;   
		ldi     Ind2,$3f          ;   1
		ldi     Ind1,$06          ;   2
		ldi     Cnt,100           ; 2    (16 000 000/1024/315/100) 

		sei                      ;   ..     
;-------------------------       ;    ! 

q:
        rjmp    q                ;

//  
Timer: 
        in      r0,SREG       
// //		   
;  ( )     1  2
		ldi     UprLed,0b11111110 	
        sbis    PORTA,0         
		ldi     UprLed,0b11111101 
;
        out     PORTA,UprLed   ;    () ...
        mov     temp,Ind1        
        sbis    PORTA,0         
        mov     temp,Ind2        		        
        out     PORTC,temp     ; 
;    
        dec     cnt
		brne    OutInt_1       ;   
; 
        ldi     cnt,100        ; 50()/100 = 2 
        cpi     Ind1,$06       ;    c 0
        breq    Digit2         ;    
        ldi     Ind2,$3f       ;0                           |
		ldi     Ind1,$06       ;1		                    |
		rjmp    OutInt_1       ;                            |
Digit2:                        ;                            |
        ldi     Ind2,$5b       ;2                          <=
		ldi     Ind1,$4f       ;3
OutInt_1:
		out     SREG,r0
OutInt:
        reti 	
;--------------------------------- 
/*
  AVR
infanata.org
 . AVR  Mega -   
        . . . AVR    -   
    (1<<xxx)
  ,  1      
..  (1<<4) = 0b0001 0000 , |  .. ""
(1<<0 | 1<<1) =0b0000 0001 or 0b0000 0010  = 0x03
~(1<<0 | 1<<1) = not (0b0000 0001 or 0b0000 0010)  = 0xfc (~)   -
       ""  .
*/
